//
//  MyQCPlugIn.m
//  MyQC
//
//  Created by muccio on 13/10/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>
#import "MyQCPlugIn.h"

#define	kQCPlugIn_Name				@"Time Displacement by Muccio"
#define	kQCPlugIn_Description		@"la map image deve essere 640*480, input frames imposta la durata in frames"

vImage_Buffer auxBuffer;
vImage_Buffer map_Buffer;
BOOL init_map=false,init_frames=false,map_error=false;

int frameCounterSize;
BOOL mappa_letta=false;
const int max_width=640,max_height=480;
unsigned char arrayMappa[2000*2000];
vImage_Buffer frame_array[100];
uint32_t *frame_array_data[100]; 

@implementation MyQCPlugIn
@dynamic inputSourceImage, outputResultImage, inputMapImage,inputFrames;
/*
Here you need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation
@dynamic inputFoo, outputBar;
*/

+ (NSDictionary*) attributes
{
	/*
	Return a dictionary of attributes describing the plug-in (QCPlugInAttributeNameKey, QCPlugInAttributeDescriptionKey...).
	*/
	
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
	/*
	Specify the optional attributes for property based ports (QCPortAttributeNameKey, QCPortAttributeDefaultValueKey...).
	*/
	
	if([key isEqualToString:@"inputFrames"])
        return [NSDictionary dictionaryWithObjectsAndKeys:
				[NSNumber numberWithInt:100], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithInt:1], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithInt:100], QCPortAttributeMaximumValueKey,nil];
	
	if([key isEqualToString:@"inputSourceImage"])
        return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Image in", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputResultImage"])
        return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Image out", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"inputMapImage"])
        return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Time Map", QCPortAttributeNameKey, nil];
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/*
	Return the execution mode of the plug-in: kQCPlugInExecutionModeProvider, kQCPlugInExecutionModeProcessor, or kQCPlugInExecutionModeConsumer.
	*/
	
	return kQCPlugInExecutionModeProcessor;
	//return kQCPlugInExecutionModeConsumer;
}

+ (QCPlugInTimeMode) timeMode
{
	/*
	Return the time dependency mode of the plug-in: kQCPlugInTimeModeNone, kQCPlugInTimeModeIdle or kQCPlugInTimeModeTimeBase.
	*/
	
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	if(self = [super init]) {
		/*
		Allocate any permanent resource required by the plug-in.
		*/
		/*
		[self addInputPortWithType:QCPortTypeIndex forKey:@"numero_frames" withAttributes:
		 [NSDictionary dictionaryWithObjectsAndKeys:
		  [NSNumber numberWithInt:25], QCPortAttributeDefaultValueKey,
		  [NSNumber numberWithInt:1], QCPortAttributeMinimumValueKey,
		  [NSNumber numberWithInt:100], QCPortAttributeMaximumValueKey,nil]
		  ];*/
		
	}
	
	return self;
}

- (void) finalize
{
	/*
	Release any non garbage collected resources created in -init.
	*/
	
	[super finalize];
}

- (void) dealloc
{
	/*
	Release any resources created in -init.
	*/
	
	[super dealloc];
}



@end

@implementation MyQCPlugIn (Execution)

- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when rendering of the composition starts: perform any required setup for the plug-in.
	Return NO in case of fatal failure (this will prevent rendering of the composition to start).
	*/
	
	
	return YES;
}

- (void) enableExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when the plug-in instance starts being used by Quartz Composer.
	*/
}

+ (unsigned char)valueWithPos:(int)i x:(int)x y:(int)y vImage:(vImage_Buffer)inBuffer
{
	if (x<0 || inBuffer.width<x || y<0 || inBuffer.height<y) {
		return (unsigned char)0;
	}
	return *((unsigned char *)(inBuffer.data+(inBuffer.rowBytes*y+4*x+i)));
}
id auxMapCheckChange;
- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	id  image,mappa;
	NSUInteger numeroF;
	
	if(numeroF=self.inputFrames){
		//NSLog(@"execute %i",self.inputFrames);
		if(!init_frames){
			init_frames=true;
			frameCounterSize=self.inputFrames;
		}
		else {
			if (frameCounterSize!=self.inputFrames) {
				init_frames=false;
				
				//return YES;
			}
		}

	}
		
	
	if(image= self.inputSourceImage) { 
		OutputImageProvider* provider = [[OutputImageProvider alloc] initWithImageSource:image]; 
		if(provider == nil) 
			return NO; 
		self.outputResultImage = provider; 
		[provider release]; 
	} 
	else 
		self.outputResultImage = nil; 
	
	if(mappa=self.inputMapImage){
		if(!init_map){		
			
			//read the time map
			NSLog(@"input map");
			if(![mappa lockBufferRepresentationWithPixelFormat:QCPlugInPixelFormatBGRA8
														 colorSpace:[mappa imageColorSpace] 
														  forBounds:[mappa imageBounds]]) {
				NSLog(@"errore 1");
				return NO; 
			}
			map_Buffer.data = (void*)[mappa bufferBaseAddress]; 
			map_Buffer.rowBytes = [mappa bufferBytesPerRow]; 
			map_Buffer.width = [mappa bufferPixelsWide]; 
			map_Buffer.height = [mappa bufferPixelsHigh];
			if(map_Buffer.width>max_width||map_Buffer.height>max_height){
				map_error=true;
				return NO;
			}
			else {
				map_error=false;
			}

				
			NSLog(@"*** map_Buffer.width,map_Buffer.height = %i,%i",map_Buffer.width,map_Buffer.height);
			init_map=TRUE;
			auxMapCheckChange=self.inputMapImage;
		}
		else {
			if(auxMapCheckChange!=mappa)
			{
				NSLog(@"map change");
				init_map=FALSE;
				mappa_letta=FALSE;
			}
		}

	}
	//NSLog(@"%i",self.inputFrames);
	return YES; 
}

- (void) disableExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when the plug-in instance stops being used by Quartz Composer.
	*/
}

- (void) stopExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when rendering of the composition stops: perform any required cleanup for the plug-in.
	*/
}

@end

@implementation OutputImageProvider
int counter=0;
int frameCounter=0;
//int frameCounterSize=100;

int frameStep;

BOOL init=false;

- (id) initWithImageSource:(id<QCPlugInInputImageSource>)image 
{ 
	if(!image) { 
		[self release]; 
		return nil; 
	} 
	if(self = [super init]) { 
		_image = [(id)image retain]; 
	} 
	return self; 
} 
- (void) dealloc 
{ 
	[(id)_image release]; 
	[super dealloc]; 
} 
- (NSRect) imageBounds 
{ 
	return [_image imageBounds]; 
} 
- (CGColorSpaceRef) imageColorSpace 
{ 
	return [_image imageColorSpace]; 
} 
- (NSArray*) supportedBufferPixelFormats 
{ 
	return [NSArray arrayWithObjects:QCPlugInPixelFormatARGB8, 
			QCPlugInPixelFormatBGRA8, 
			QCPlugInPixelFormatRGBAf, 
			nil]; 
} 

+ (unsigned char)valueWithPos_:(int)i x:(int)x y:(int)y vImage:(vImage_Buffer)inBuffer
{
	if (x<0 || inBuffer.width<x || y<0 || inBuffer.height<y) {
		return (unsigned char)0;
	}
	return *((unsigned char *)(inBuffer.data+(inBuffer.rowBytes*y+4*x+i)));
}

- (BOOL) renderToBuffer:(void*)baseAddress 
		withBytesPerRow:(NSUInteger)rowBytes 
			pixelFormat:(NSString*)format 
			  forBounds:(NSRect)bounds 
{ 
	vImage_Buffer inBuffer, outBuffer, copy_buffer;
	if(![_image lockBufferRepresentationWithPixelFormat:format 
											 colorSpace:[_image imageColorSpace] 
											  forBounds:bounds]) 
		return NO; 	
	inBuffer.data = (void*)[_image bufferBaseAddress]; 
	inBuffer.rowBytes = [_image bufferBytesPerRow]; 
	inBuffer.width = [_image bufferPixelsWide]; 
	inBuffer.height = [_image bufferPixelsHigh]; 
	outBuffer.data = baseAddress; 
	outBuffer.rowBytes = rowBytes; 
	outBuffer.width = [_image bufferPixelsWide]; 
	outBuffer.height = [_image bufferPixelsHigh]; 
	copy_buffer.data = baseAddress; 
	copy_buffer.rowBytes = rowBytes; 
	copy_buffer.width = [_image bufferPixelsWide]; 
	copy_buffer.height = [_image bufferPixelsHigh]; 
	uint64_t size_=inBuffer.rowBytes * inBuffer.height;
	//test input map and buffer dimensions
	if (inBuffer.width>max_width||inBuffer.height>max_height) {
		memset(outBuffer.data,0x00,size_);
		return YES;
	}
	//if(map_Buffer.width>max_width||map_Buffer.height>max_height){
	if(map_error){
		memset(outBuffer.data,0xFF,size_);
		return YES;
	}
	if(init_map&&!mappa_letta)
	{
		//init map array
		//arrayMappa = malloc(map_array_size);
		NSLog(@"arrayMappa size=%i",sizeof(arrayMappa));
		memset(arrayMappa,0x00,sizeof(arrayMappa));
		NSParameterAssert( arrayMappa != NULL );
		
		unsigned long i, j;
		for(j= 0; j<map_Buffer.height; j++) {	
			for(i= 0; i<map_Buffer.width; i++) {
				unsigned char v=[OutputImageProvider valueWithPos_:0 x:i y:j vImage:map_Buffer];
				arrayMappa[i+j*map_Buffer.width]=v;
			}
		}
		
		mappa_letta=true;
		
		NSLog(@"valori della mappa letti");
		for(int righe=0;righe<map_Buffer.height;righe++){
			float divisore=256.0/frameCounterSize;
			int valore_temporale_mappa=(int)arrayMappa[righe*map_Buffer.width]/divisore;
			NSLog(@"[%i]=%i %i",righe,arrayMappa[righe*map_Buffer.width],valore_temporale_mappa);
		}
		/*NSLog(@"ex.: arrayMappa = %i %i %i %i",arrayMappa[0],arrayMappa[1],arrayMappa[2],arrayMappa[3]);
		NSLog(@"ex.: arrayMappa = %i %i %i %i",	arrayMappa[map_Buffer.width*map_Buffer.height-4],
												arrayMappa[map_Buffer.width*map_Buffer.height-3],
												arrayMappa[map_Buffer.width*map_Buffer.height-2],
												arrayMappa[map_Buffer.width*map_Buffer.height-1]);
		*/
		NSLog(@"size of mappa:%i",sizeof(arrayMappa));
	}
	//inizializzazione buffer frame
	if(!init){
		NSLog(@"malloc%i",frameCounter);
		frame_array_data[frameCounter] = malloc(size_*2);
		NSParameterAssert( frame_array_data[frameCounter] != NULL );
		frame_array[frameCounter].data = frame_array_data[frameCounter];
		frame_array[frameCounter].rowBytes=rowBytes;
		frame_array[frameCounter].width = [_image bufferPixelsWide];
		frame_array[frameCounter].height = [_image bufferPixelsHigh];
	}
	
	memcpy(frame_array[frameCounter].data, inBuffer.data, size_);
	frameCounter++;
    if(frameCounter>frameCounterSize){
		frameCounter=0;
		init=TRUE;
	}
	if(init){
		if(mappa_letta){
			memset(outBuffer.data,0x00,size_);
			/*
			int temp_fc=0;
			int divisioni_orizzontali=frameCounterSize;
			for(int parametro=0;parametro<divisioni_orizzontali;parametro++){
				temp_fc=frameCounter-(parametro+1);if(temp_fc<0){temp_fc=frameCounterSize+temp_fc;}
				memcpy(outBuffer.data+parametro*(size_/divisioni_orizzontali), 
			 frame_array[temp_fc].data+parametro*(size_/divisioni_orizzontali), (size_/divisioni_orizzontali));
			}
			*/
			float divisore=256.0/frameCounterSize;
			for(int pixel_della_mappa=0;pixel_della_mappa<map_Buffer.width*map_Buffer.height;pixel_della_mappa++){
				int valore_temporale_mappa=(int)arrayMappa[pixel_della_mappa]/divisore;
				
				int aux_frame_counter=frameCounter-(int)valore_temporale_mappa;
				if(aux_frame_counter<0){aux_frame_counter=frameCounterSize+aux_frame_counter;}
				/*
				if(pixel_della_mappa%map_Buffer.width==0){
					
					NSLog(@"pixel=%i frameC=%i valore_mappa=%i aux_fcounter=%i",pixel_della_mappa,frameCounter,
						  valore_temporale_mappa,aux_frame_counter);
					 
					NSLog(@"pixel(%i) arrayM(%i) valore_t(%i) fc(%i)",
						  pixel_della_mappa/map_Buffer.width,arrayMappa[pixel_della_mappa],valore_temporale_mappa,aux_frame_counter);
				}*/
								
				memcpy(outBuffer.data+pixel_della_mappa*4,
					   frame_array[aux_frame_counter].data+pixel_della_mappa*4,4);
				//memcpy(outBuffer.data+pixel_della_mappa*4,inBuffer.data+pixel_della_mappa*4,4);					
			}
		}
		else {
			memcpy(outBuffer.data,inBuffer.data,size_);
		}
	}
	else {
		memcpy(outBuffer.data,inBuffer.data,size_);
	}
	[_image unlockBufferRepresentation]; 
	return YES; 
} 
@end